# Opens class Geom::Point3d.
class Geom::Point3d

  # Adds a method called on_edge? to the Geom::Point3d class, which returns true if our point
  # is on the edge and false if not.
  def on_edge?(edge)
    
    # Starting and ending point3d of the edge.
    pt_start = edge.start.position
    pt_end = edge.end.position
      
    # self is a point3d which we are testing.
    # self.distance(pt_start) is the distance from our point to the start point of the edge.
    # self.distance(pt_end) is the distance from our point to the end point of the edge.
    d1 = (self.distance(pt_start) + self.distance(pt_end))
    
    # d2 is the length of the edge.
    d2 = pt_start.distance(pt_end) + 0
    
    # Tests if our point is on the edge (tolerates a really small offset).
    if (d1 <= d2) or (d1-d2 < 1e-10)
      return true
    else
      return false
    end
    
    # Safe-lock.    
    return UI.messagebox("Something is wrong.")
  
  end
end