require "sketchup.rb"

# Requires Grid positioning.rb and Create 3D grid.rb via a relative path.
$main_path = File.dirname(__FILE__)
require_all("#{$main_path}/Grid setup")



# Adds User Interface to the menus in SketchUp.
if( not file_loaded?("Grid positioning.rb") or not file_loaded?("Create 3D grid.rb") ) then

  grid = Grid.new

  # Adding the tree structure to Plugins menu.
  plugins_menu = UI.menu "Plugins"
  grid_menu = plugins_menu.add_submenu("Grid setup")
  grid_menu.add_item("Draw a 3D grid") do
   grid.create_3d_grid
  end
  grid_menu.add_item("Position at grid intersections") do
   grid.grid_positioning(Sketchup.active_model.selection)
  end
  

  # Adding the tree structure to the selection options.
  UI.add_context_menu_handler do |context_menu| 
    context_menu.add_separator
    grid_popup = context_menu.add_submenu("Grid setup")
    grid_popup.add_item("Draw a 3D grid") do
      grid.create_3d_grid
    end
    grid_popup.add_item("Position at grid intersections") do
      grid.grid_positioning(Sketchup.active_model.selection)
    end
  end

end

file_loaded("Create 3D grid.rb")
file_loaded("Grid positioning.rb")

